`timescale 1ns / 1ps
// Anthony Curnes
// this is an 2-to-1 parameterized multiplexer
module mux2to1(out, sel, a, b);
    // initializing parameter
    parameter n = 1;

    // input and output declarations
    input [n-1:0] a, b;
    input sel;
    output [n-1:0] out;

    // out is assigned input a-h depending on sel
    assign out =    sel == 0 ? a :
                    sel == 1 ? b : 1'b0;

endmodule