`timescale 1ns / 1ps
// Anthony Curnes
// this is an 4-to-1 parameterized multiplexer
module mux4to1(out, sel, a, b, c, d);
    // initializing parameter
    parameter n = 1;

    // input and output declarations
    input [n-1:0] a, b, c, d;
    input [1:0] sel;
    output [n-1:0] out;

    // out is assigned input a-h depending on sel
    assign out =    sel == 2'b00 ? a :
                    sel == 2'b01 ? b :
                    sel == 2'b10 ? c :
                    sel == 2'b11 ? d : 1'b0;


endmodule
