// VERSION 1.1ss

module one_pulse(clk, rst, btn, pulse_out);
  
  input clk, rst, btn;
  output pulse_out;

  wire q0, q1;
   
  Nbit_reg #(1) Q0(.clk(clk), 
		       .rst(rst), 
		       .we(1'b1),
		       .gwe(1'b1),
		       .in((btn & ~q0 & ~q1)), 
		       .out(q0));
  Nbit_reg #(1) Q1(.clk(clk), 
		       .rst(rst), 
		       .we(1'b1),
		       .gwe(1'b1),
		       .in(((q0 | q1) & btn)), 
		       .out(q1));

  assign pulse_out = q0;

endmodule

//A one-pulse module that resets to high, not low
module one_pulse_rst_high(clk, rst, btn, pulse_out);
  
  input clk, rst, btn;
  output pulse_out;

  wire q0, q1;
   
  Nbit_reg #(1,1) Q0(.clk(clk), 
		       .rst(rst), 
		       .we(1'b1),
		       .gwe(1'b1),
		       .in((btn & ~q0 & ~q1)), 
		       .out(q0));
  Nbit_reg #(1,1) Q1(.clk(clk), 
		       .rst(rst), 
		       .we(1'b1),
		       .gwe(1'b1),
		       .in(((q0 | q1) & btn)), 
		       .out(q1));

  assign pulse_out = q0;

endmodule
